VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "VolInfo"
   ClientHeight    =   4455
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   3255
   Height          =   4860
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   3255
   Top             =   1170
   Width           =   3375
   Begin VB.TextBox txtResults 
      Height          =   3735
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   3
      Top             =   720
      Width           =   3255
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Get Information"
      Default         =   -1  'True
      Height          =   495
      Left            =   1920
      TabIndex        =   2
      Top             =   120
      Width           =   1335
   End
   Begin VB.TextBox txtDrive 
      Height          =   285
      Left            =   600
      TabIndex        =   1
      Text            =   "C:\"
      Top             =   240
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Drive"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   375
   End
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function GetVolumeInformation Lib "kernel32" Alias "GetVolumeInformationA" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As String, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, lpMaximumComponentLength As Long, lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As String, ByVal nFileSystemNameSize As Long) As Long

Private Const FS_CASE_IS_PRESERVED = &H2
Private Const FS_CASE_SENSITIVE = &H1
Private Const FS_UNICODE_STORED_ON_DISK = &H4
Private Const FS_PERSISTENT_ACLS = &H8
Private Const FS_FILE_COMPRESSION = &H10
Private Const FS_VOL_IS_COMPRESSED = &H8000&

Private Declare Function GetDiskFreeSpace Lib "kernel32" Alias "GetDiskFreeSpaceA" (ByVal lpRootPathName As String, lpSectorsPerCluster As Long, lpBytesPerSector As Long, lpNumberOfFreeClusters As Long, lpTotalNumberOfClusters As Long) As Long
Private Sub Command1_Click()
Dim txt As String
Dim volume_name As String * 256
Dim file_system_name As String * 256
Dim serial_number As Long
Dim component_length As Long
Dim system_flags As Long
Dim sectors_per_cluster As Long
Dim bytes_per_sector As Long
Dim free_clusters As Long
Dim total_clusters As Long
Dim total_bytes As Long
Dim free_bytes As Long

    If GetVolumeInformation(txtDrive.Text, _
        volume_name, Len(volume_name), _
        serial_number, component_length, _
        system_flags, file_system_name, _
        Len(file_system_name)) = 0 _
    Then
        txt = "Error in GetVolumeInformation."
    Else
        txt = txtDrive.Text
        volume_name = Left$(volume_name, InStr(volume_name, Chr$(0)) - 1)
        txt = txt & vbCrLf & "Volume Name: " & volume_name
        txt = txt & vbCrLf & "Serial number: " & Format$(serial_number)
        txt = txt & vbCrLf & "Max component length: " & Format$(component_length)
        txt = txt & vbCrLf & "System Flags: "
        If system_flags And FS_CASE_IS_PRESERVED Then txt = txt & vbCrLf & "    FS_CASE_IS_PRESERVED"
        If system_flags And FS_CASE_SENSITIVE Then txt = txt & vbCrLf & "    FS_CASE_SENSITIVE"
        If system_flags And FS_UNICODE_STORED_ON_DISK Then txt = txt & vbCrLf & "    FS_UNICODE_STORED_ON_DISK"
        If system_flags And FS_PERSISTENT_ACLS Then txt = txt & vbCrLf & "    FS_PERSISTENT_ACLS"
        If system_flags And FS_FILE_COMPRESSION Then txt = txt & vbCrLf & "    FS_FILE_COMPRESSION"
        If system_flags And FS_VOL_IS_COMPRESSED Then txt = txt & vbCrLf & "    FS_VOL_IS_COMPRESSED"
        file_system_name = Left$(file_system_name, InStr(file_system_name, Chr$(0)) - 1)
        txt = txt & vbCrLf & "File System: " & file_system_name
    End If

    If GetDiskFreeSpace(txtDrive.Text, _
        sectors_per_cluster, bytes_per_sector, _
        free_clusters, total_clusters) = 0 _
    Then
        txt = txt & vbCrLf & "Error in GetDiskFreeSpace."
    Else
        txt = txt & vbCrLf & "Sectors Per Cluster: " & Format$(sectors_per_cluster)
        txt = txt & vbCrLf & "Bytes Per Sector: " & Format$(bytes_per_sector)
        txt = txt & vbCrLf & "Free Clusters: " & Format$(free_clusters)
        txt = txt & vbCrLf & "Total Clusters: " & Format$(total_clusters)
        total_bytes = total_clusters * sectors_per_cluster * bytes_per_sector
        txt = txt & vbCrLf & "Total Bytes: " & Format$(total_bytes)
        free_bytes = free_clusters * sectors_per_cluster * bytes_per_sector
        txt = txt & vbCrLf & "Bytes Free: " & Format$(free_bytes)
        txt = txt & vbCrLf & "Percent Used: " & Format$(1 - (free_bytes / total_bytes), "0.00%")
    End If
    
    txtResults.Text = txt
End Sub

